//<c>   Copyright 1991-1998 by Gerry J. Danen; all rights reserved.

//<t>   Header for Timed message logs

#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_nw.h"
#include"dbc.h"
#include"gd_db.h"
#include"nit.h"
#include<stdarg.h>
#ifdef TMSG_LOG_
  #include"tr_login.hhh"
  #include"tr_menus.hhh"
#endif

#define         pgVERS_         "V3.31"
#define         pgCOPR_         "1991"
#ifdef TMSG_
  #define       pgTITL_         "Track Messages"
#endif
#ifdef TMSG_LOG_
  #define       pgTITL_         "Update Message Tracking Database"
#endif


#define         LOGVOL_NET      "SYS:DATA\\"
#define         LOGVOL          "C:\\"
#define         LOGDIR          "LOGS"
#define         LOGFILE         "LOGMSG."


UCHAR   abortmsg[161], archfile[]="19960101.DAT", ignrfile[]="IGNORED.DAT",
        fmtdata[]="%s%s\\%sDAT", fmtwork[]="%s%s\\%s$$$", datafile[255], workfile[255],
        serverName[48], userName[48], node_addr[13] ;
INT32   sys_ymd, sys_hms ;
BOOL    on_network = TRUE ;


void    abort_job( int excode, STRING msg, ... )
{
    va_list     arg_ptr ;

    va_start( arg_ptr, msg );
    vsprintf( abortmsg, msg, arg_ptr );
    va_end( arg_ptr );
    fprintf( stderr, "\nProgram %s: Error Code %d\a\n\t%s\n", pgm_name, excode, abortmsg );
#ifdef TMSG_LOG_
    dBclose( tr_login_db );
    dBclose( tr_login_db );
#endif
    fcloseall();
    exit( excode );
}


void    init_job( void )
{
    INT16       i1, i2, i3, i4 ;
    INT32       tics ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    dt_getsystemdate( &sys_ymd, &i1, &i2, &i3 );
    tm_getsystemtime( &sys_hms, &tics, &i1, &i2, &i3, &i4 );

    if ( nw_installed_NetWare() )
        on_network = TRUE ;
    else
        on_network = FALSE ;

    if ( on_network )
    {
        strcpy( serverName, nw_server_name( nw_get_default_connection_id() ) );
        nw_get_username( userName );
//      long    objectID ;
//      WORD    objectType ;
//      BYTE    loginTime[7] ;
//      GetFileServerName( (WORD) 0, serverName );
//      GetConnectionInformation( GetConnectionNumber(), userName, &objectType, &objectID, loginTime );
        if ( strlen(serverName) < 1 || strlen(userName) < 1 )
            on_network = FALSE ;
    }

    if ( on_network )
    {
        sprintf( datafile, fmtdata, LOGVOL_NET, LOGDIR, LOGFILE );
        sprintf( workfile, fmtwork, LOGVOL_NET, LOGDIR, LOGFILE );
    }
    else
    {
        sprintf( workfile, "%s%s", LOGVOL, LOGDIR );
        dr_mkdir( workfile, NO );
        sprintf( datafile, fmtdata, LOGVOL, LOGDIR, LOGFILE );
        sprintf( workfile, fmtwork, LOGVOL, LOGDIR, LOGFILE );
    }
}
