//<c>   Copyright 1991-1998 by Gerry J. Danen; all rights reserved.

//<t>   Update TMSG database

#define TMSG_LOG_
#include"project.h"

#if ! LARGE_MODEL
//  #error  Must be large memory model
#endif


#define         NUM_REC_LOGIN   6               //  login/logout tracking
dBFIELD         rec_login[ NUM_REC_LOGIN ] =    //  to create dbf file
{
                "SERVER",       'C',  8, 0,
                "USER",         'C',  8, 0,
                "STATION",      'C', 12, 0,
                "TR_DATE",      'D',  8, 0,
                "TR_TIME",      'N',  8, 0,
                "TR_WHAT",      'C',  1, 0
};


#define         NUM_REC_MENUS   7               //  menu usage tracking
dBFIELD         rec_menus[ NUM_REC_MENUS ] =    //  to create dbf file
{
                "SERVER",       'C',  8, 0,
                "USER",         'C',  8, 0,
                "STATION",      'C', 12, 0,
                "TR_DATE",      'D',  8, 0,
                "TR_TIME",      'N',  8, 0,
                "TR_WHAT",      'C',  1, 0,
                "MENU",         'C', 12, 0
};


UCHAR           bigbuf[ TR_MENUS_STR_SIZE ] ;   //  common buffer
UCHAR           record[ TR_MENUS_STR_SIZE ] ;   //  DBF record
long            tr_login_recs=0, tr_menus_recs=0, skipped_recs=0 ;

UCHAR           work[1001], *w, w1[131], w2[131], saved[256],
                w_date[131], w_time[131], w_node[131], w_srvr[131], w_user[131] ;
BOOL            alt_file = FALSE ;


void    open_dbf( void )
{
    if ( ! fl_exist( tr_login_dbf ) )
        dBcreat( tr_login_dbf, (FLDNUM) NUM_REC_LOGIN, rec_login );
    if ( dBopen( tr_login_dbf, &tr_login_db ) != SUCCESS )
        abort_job( 11, "Unable to open login/logout tracking database" );
    if ( ! fl_exist( tr_menus_dbf ) )
        dBcreat( tr_menus_dbf, (FLDNUM) NUM_REC_MENUS, rec_menus );
    if ( dBopen( tr_menus_dbf, &tr_menus_db ) != SUCCESS )
        abort_job( 11, "Unable to open menu tracking database" );
}


void    main( int argc, char *argv[] )
{
    FILE        *in, *ign ;
    int         ret ;

    init_job();
    sprintf( archfile, "%08ld.DAT", sys_ymd );
    if ( strlen(argv[1]) )
    {
        if ( fl_exist( argv[1] ) )
            alt_file = TRUE ;
    }
    if ( ! alt_file )
    {
        if ( fl_exist( archfile ) )
            abort_job( 1, "Archive file %s already exists.  Try again tomorrow!", archfile );
    }
    open_dbf();

    if ( alt_file )
    {
        strupr( argv[1] );
        in = fopen( argv[1], "r" );
        if ( ! in )
            abort_job( 1, "Could not open alternate workfile %s", argv[1] );
    }
    else
    {
        ret = rename( datafile, workfile );
        if ( ret != 0 )
            abort_job( 1, "Unable to rename %s to %s", datafile, workfile );
        in = fopen( workfile, "r" );
        if ( ! in )
            abort_job( 1, "Could not open workfile %s", workfile );
    }
    ign = fopen( ignrfile, "a+" );
    for (;;)
    {
        w = fgets( work, 1000, in );
        if ( w )
        {
            st_reduce_spaces( work );
            ST_CPY( saved, work );
            work[131] = EOS ;
            SplitString( work, ":", w1, w2 );
            st_get_word   ( w_date, w1 );
            st_remove_word( w1 );
            st_get_word   ( w_time, w1 );
            st_remove_word( w1 );
            st_get_word   ( w_node, w1 );
            st_remove_word( w1 );
            st_get_word   ( w_srvr, w1 );
            st_remove_word( w1 );
            st_get_word   ( w_user, w1 );
            st_remove_word( w1 );
            st_get_word   ( w1, w2 );
            st_remove_word( w2 );
            if ( StrEq(w1,"I") || StrEq(w1,"O") )   //  login/logout
            {
                st_cpy( tr_login.server , w_srvr, 9 );
                st_cpy( tr_login.user   , w_user, 9 );
                st_cpy( tr_login.station, w_node, 13);
                st_cpy( tr_login.tr_date, w_date, 9 );
                st_cpy( tr_login.tr_time, w_time, 9 );
                tr_login.tr_what = w1[0] ;
                if ( add_dbf_record( &tr_login_db, tr_login_dbf, (UCHAR *) &tr_login, tr_login_fdefs ) != OK )
                    abort_job( 3, bigbuf );
                tr_login_recs += 1 ;
            }
            else
            if ( StrEq(w1,"*") )                //  menus
            {
                st_cpy( tr_menus.server , w_srvr, 9 );
                st_cpy( tr_menus.user   , w_user, 9 );
                st_cpy( tr_menus.station, w_node, 13);
                st_cpy( tr_menus.tr_date, w_date, 9 );
                st_cpy( tr_menus.tr_time, w_time, 9 );
                st_get_word( w1, w2 );
                st_remove_word( w2 );
                st_cpy( tr_menus.menu, w1, 13 );
                st_get_word( w1, w2 );
                st_remove_word( w2 );
                if ( StrEq(w1,"in") )
                    tr_menus.tr_what = 'I' ;
                else
                if ( StrEq(w1,"out") )
                    tr_menus.tr_what = 'O' ;
                else
                    tr_menus.tr_what = ' ' ;
                if ( add_dbf_record( &tr_menus_db, tr_menus_dbf, (UCHAR *) &tr_menus, tr_menus_fdefs ) != OK )
                    abort_job( 3, bigbuf );
                tr_menus_recs += 1 ;
            }
            else
            {
                if ( ign )
                    fprintf( ign, "%s\n", saved );
                skipped_recs += 1 ;
            }
        }
        if ( feof(in) )
        {
            dBclose( tr_login_db );
            dBclose( tr_menus_db );
            fcloseall();
            fprintf( stderr, "%12ld records written to %s\n"
                             "%12ld records written to %s\n"
                             "%12ld records ignored\n",
                             tr_login_recs, tr_login_dbf,
                             tr_menus_recs, tr_menus_dbf,
                             skipped_recs );
            if ( ! alt_file )
            {
                ret = rename( workfile, archfile );
                if ( ret != 0 )
                    abort_job( 1, "Unable to rename %s to %s", workfile, archfile );
            }
            exit( GOOD_EXIT );
        }
    }
}
